#
# Conditional build:
%bcond_without	jumbopatch	# This patch integrates lots of contributed
				# patches adding support for over 30
				# of additional hash types, and more.
%bcond_with	avx		# use x86 AVX instructions
%bcond_with	xop		# use x86 XOP instructions
%bcond_with	altivec		# use PPC Altivec instructions
#
%ifarch i586 i686 athlon pentium2 pentium3 pentium4
%define do_mmx 1
%else
%define	do_mmx 0
%endif
%ifarch	i686 athlon pentium4
%define	do_sse2 1
%else
%define	do_sse2 0
%endif
%ifarch i586 i686
%define do_mmxfb 1
%define	optmmxfb	-DCPU_FALLBACK=1
%else
%define do_mmxfb 0
%undefine optmmxfb
%endif
%ifarch i686 athlon
%define	do_ssefb 1
%define	optssefb	-DCPU_FALLBACK=1
%else
%define	do_ssefb 0
%define	optssefb
%endif
Summary:	Password cracker
Summary(pl.UTF-8):	Łamacz haseł
Name:		john
Version:	1.7.9
Release:	3
License:	GPL v2
Group:		Applications/System
Source0:	http://www.openwall.com/john/g/%{name}-%{version}.tar.bz2
# Source0-md5:	45f54fc59386ecd67daaef9f19781d93
Patch0:		%{name}-mailer.patch
Patch1:		optflags.patch
Patch2:		http://www.openwall.com/john/g/%{name}-1.7.9-jumbo-7.diff.gz
# Patch2-md5:	b953fcb7f743eeeb5f938a28c352b8ef
Patch3:		%{name}-jumbo-optflags.patch
Patch4:		no-inline.patch
URL:		http://www.openwall.com/john/
%{?with_jumbopatch:BuildRequires: openssl-devel >= 0.9.7}
BuildRequires:	rpmbuild(macros) >= 1.213
Requires:	words
%ifarch %{ix86} %{x8664}
%if %{with xop}
Requires:	cpuinfo(xop)
%endif
%if %{with xop} || %{with avx}
Requires:	cpuinfo(avx)
%endif
%if %{do_sse2} && !%{do_ssefb}
Requires:	cpuinfo(sse2)
%endif
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
John the Ripper is a fast password cracker, currently available for
many flavors of Unix (11 are officially supported, not counting
different architectures), DOS, Win32, BeOS, and OpenVMS (the latter
requires a contributed patch). Its primary purpose is to detect weak
Unix passwords. Besides several crypt(3) password hash types most
commonly found on various Unix flavors, supported out of the box are
Kerberos/AFS and Windows NT/2000/XP LM hashes, plus several more with
contributed patches.

%description -l pl.UTF-8
John The Ripper jest szybkim "łamaczem" haseł dostępnym dla wielu
rodzajów uniksów (oficjalnie obsługiwanych jest 11, nie licząc różnych
architektur), DOS-a, Win32, BeOS-a i OpenVMS-a (ten ostatni wymaga
łaty). Głównym zastosowaniem jest wykrywanie słabych haseł uniksowych.
Oprócz różnych rodzajów skrótów haseł crypt(3) najczęściej używanych
na różnych uniksach, obsługiwane są także skróty Kerberos/AFS oraz
Windows NT/2000/XP LM, a także kilka innych przy użyciu łat.

%prep
%setup -q
%patch0 -p1
%{!?with_jumbopatch:%patch1 -p1}
%{?with_jumbopatch:%patch2 -p1}
%{?with_jumbopatch:%patch3 -p1}
%ifarch %{x8664}
%patch4 -p1
%endif

%{__rm} doc/INSTALL

%build
cd src

cat > defs.h <<'EOF'
#define	JOHN_SYSTEMWIDE 1
#define	JOHN_SYSTEMWIDE_EXEC "%{_libdir}/john"
EOF

%if %{do_mmxfb}
%{__make} linux-x86-any \
	CC="%{__cc}" \
	OPTFLAGS="%{rpmcflags} -include defs.h"
mv ../run/john ../run/john-non-mmx
%{__make} clean
%endif

%if %{do_ssefb}
%{__make} linux-x86-mmx \
	CC="%{__cc}" \
	OPTFLAGS="%{rpmcflags} -include defs.h %{?optmmxfb}"
mv ../run/john ../run/john-non-sse
%{__make} clean
%endif

TARG=generic
%ifarch %{x8664}
	TARG=linux-x86-64%{?with_xop:-xop}%{!?with_xop:%{?with_avx:-avx}}
%endif
%ifarch	%{ix86}
	%if %{with xop} || %{with avx}
		TARG=linux-x86%{?with_xop:-xop}%{!?with_xop:%{?with_avx:-avx}}
	%else
		%if %{do_sse2}
			TARG=linux-x86-sse2
		%else
			%if %{do_mmx}
				TARG=linux-x86-mmx
			%else
				TARG=linux-x86-any
			%endif
		%endif
	%endif
%endif
%ifarch ppc
	TARG=linux-ppc32%{?with_altivec:-altivec}
%endif
%ifarch ppc64
	TARG=linux-ppc64%{?with_altivec:-altivec}
%endif
%ifarch alpha
	TARG=linux-alpha
%endif
%ifarch ia64
	TARG=linux-ia64
%endif
%ifarch sparc sparcv9
	TARG=linux-sparc
%endif

%{__make} $TARG \
	CC="%{__cc}" \
	OPTFLAGS='%{rpmcflags} -include defs.h %{?optmmxfb}'

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_datadir}/john}
cp -a run/{*.conf,*.chr,*.lst} $RPM_BUILD_ROOT%{_datadir}/john
install -p run/john $RPM_BUILD_ROOT%{_bindir}
%if %{do_mmxfb}
install -D -p run/john-non-mmx $RPM_BUILD_ROOT%{_libdir}/john/john-non-mmx
%endif
%if %{do_ssefb}
install -D -p run/john-non-sse $RPM_BUILD_ROOT%{_libdir}/john/john-non-sse
%endif

ln -sf john $RPM_BUILD_ROOT%{_bindir}/unafs
ln -sf john $RPM_BUILD_ROOT%{_bindir}/unique
ln -sf john $RPM_BUILD_ROOT%{_bindir}/unshadow

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc doc/* run/mailer
%attr(755,root,root) %{_bindir}/john
%attr(755,root,root) %{_bindir}/unafs
%attr(755,root,root) %{_bindir}/unique
%attr(755,root,root) %{_bindir}/unshadow
%if %{do_mmxfb} || %{do_ssefb}
%dir %{_libdir}/john
%if %{do_mmxfb}
%attr(755,root,root) %{_libdir}/john/john-non-mmx
%endif
%if %{do_ssefb}
%attr(755,root,root) %{_libdir}/john/john-non-sse
%endif
%endif
%{_datadir}/john
%changelog
* Sun Jul 21 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/john.git;a=log;h=master

* Sun Jul 21 2013 Jan Rękorajski <baggins@pld-linux.org> 657a6df
- release 3 (by relup.sh)

* Sun Jul 21 2013 Jan Rękorajski <baggins@pld-linux.org> 8165090
- disable some inlining on x8664

* Sat Sep 29 2012 Adam Gołębiowski <adamg@pld-linux.org> 2d0f4c8
- release 2

* Sat Sep 29 2012 Adam Gołębiowski <adamg@pld-linux.org> 0fb1fdb
- jumbo patch up to 1.7.9-jumbo-7

* Mon Jul 23 2012 Jakub Bogusz <qboosh@pld-linux.org> 5951e27
- one more make clean

* Sat Jul 14 2012 Adam Gołębiowski <adamg@pld-linux.org> 29bcf97
- apply jumbo patch by default

* Sat Jul 14 2012 Adam Gołębiowski <adamg@pld-linux.org> 7b8fa69
- jumbo patch up to 1.7.9-jumbo-6

* Sat Dec 31 2011 Adam Gołębiowski <adamg@pld-linux.org> 5ffc47b
- rediffed against jumbo-1.7.9-5

* Sat Dec 31 2011 Adam Gołębiowski <adamg@pld-linux.org> 0e93232
- jumbo patch up to 1.7.9-jumbo-5

* Sun Nov 27 2011 Jakub Bogusz <qboosh@pld-linux.org> 2f02f70
- updated to 1.7.9 (no jumbo path for this version yet)
- updated optflags patch

* Sun Jul 03 2011 Adam Gołębiowski <adamg@pld-linux.org> 66830fd
- new

* Sun Jul 03 2011 Adam Gołębiowski <adamg@pld-linux.org> 5d94b02
- store jumbo patch in df
- solve conflict between optflags and jumbo patches

* Sun Jul 03 2011 Adam Gołębiowski <adamg@pld-linux.org> d0c6909
- missing endif

* Sun Jul 03 2011 Adam Gołębiowski <adamg@pld-linux.org> 0c5293d
- updated to 1.7.8; jumbo patch updated to 1.7.8-jumbo-2

* Sun Jul 03 2011 Adam Gołębiowski <adamg@pld-linux.org> 663c478
- no bcond for Patch/Source, need all files in srpm

* Sat Apr 30 2011 Jakub Bogusz <qboosh@pld-linux.org> 6ba1637
- cpuinfo() requires for xop/avx/sse2

* Sat Apr 30 2011 Jakub Bogusz <qboosh@pld-linux.org> 2029991
- updated to 1.7.7
- build with sse2 support on i686/athlon/pentium4 (with fallback on i686/athlon)
- bcond to enable avx or xop on x86*
- bcond to enable altivec on ppc*
- use more specific targets for ppc* and ia64

* Fri Nov 05 2010 Elan Ruusamäe <glen@pld-linux.org> 582fa29
- fix ix86 build, by passing JOHN_SYSTEMWIDE_EXEC via include file; rel 2

* Fri Nov 05 2010 Elan Ruusamäe <glen@pld-linux.org> 3443e32
- add optflags patch, cosmetics

* Thu Nov 04 2010 Elan Ruusamäe <glen@pld-linux.org> eea2a06
- up to 1.7.6

